// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['pdf','ionic','ionic.service.core', 'sculapio.controllers','ngCordova','ngTagsInput','ngResource','ngIOS9UIWebViewPatch'])

.run(function($ionicPopup, $ionicHistory, $ionicPlatform, $rootScope, $localstorage, $location, $state, MessagesTotal) {

  $ionicPlatform.registerBackButtonAction(function(e){

  function showConfirm() {
    var confirmPopup = $ionicPopup.confirm({
      title: '<strong>Exit Sculapio?</strong>',
      template: 'Are you sure you want to exit?'
    });

    confirmPopup.then(function(res) {
      if (res) {
        ionic.Platform.exitApp();
      } else {
        // Don't close
      }
    });
  }

    if ($ionicHistory.backView()) {
      $ionicHistory.goBack();
    }
    else {
      showConfirm();
    }
    e.preventDefault();
    return false;
  },101);


  $rootScope.globals2 = $localstorage.getObject('globals2') || {};

      if ($rootScope.globals2.currentUser) {
        var avatarimg = 'http://sculapio.com/assets/res/users/'+($rootScope.globals2.currentUser.foto || 'no-user.png');
        Ionic.User.load($rootScope.globals2.currentUser.idusuario).then(
          function(loadedUser){
            Ionic.User.current(loadedUser);
            user = Ionic.User.current();
          }, 
          function(error){
            console.log('something went wrong: ',error);
          });
      }

      $rootScope.$on('$locationChangeStart', function (event, next, current) {
        // redirect to login page if not logged in
        if ( ($location.path() !== '/splash' && $location.path() !== '/forgot' )  && !$rootScope.globals2.currentUser) {
            $location.path('/splash');
        }
    }); 

  $ionicPlatform.ready(function() {


    Ionic.io();
    var user = Ionic.User.current();

    //PUSH
    var push = new Ionic.Push({
      // "debug": true,
      onNotification: function(notification){
        if (notification._payload.state && !notification._raw.additionalData.foreground ) {
          $state.go(notification._payload.state, JSON.parse(notification._payload.stateParams));
        }
        MessagesTotal.get({
          idusuario: $rootScope.globals2.currentUser.idusuario,
          idespecialidad: $rootScope.globals2.currentUser.especialidades_usuario
        }).$promise.then(function(res){
          $rootScope.mensajes.total = res.total;
        });
      },
      "pluginConfig": {
        "ios": {
          "badge": true,
          "sound": true
        },
        "android": {
          "iconColor": "#0171bb",
          "icon": "sculapio_ic"
        }
      }
    });

    push.register(function(pushToken) {
      var user = Ionic.User.current();
      user.id = $rootScope.globals2.currentUser.idusuario;
      user.set('image', avatarimg);
      user.set('name', $rootScope.globals2.currentUser.nombre);
      console.log("Device token:",pushToken.token);
      user.addPushToken(pushToken);
      user.save();
    }); 



    if (typeof analytics !== 'undefined'){
      analytics.startTrackerWithId('UA-60237230-1');
      analytics.trackView('App First Tracking');
    }

    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);

    }
    // if (window.StatusBar) {
    //   // org.apache.cordova.statusbar required
    //   StatusBar.styleDefault();
    // }
  if (window.StatusBar) {
    if (ionic.Platform.isAndroid()) {
      StatusBar.backgroundColorByHexString('#00395e');
    } else {
      // StatusBar.styleLightContent();
    }
  }      
  });
})

.config(function($stateProvider, $urlRouterProvider, $sceProvider) {

  $sceProvider.enabled(false);

  $stateProvider

  .state('splash', {
    url: "/splash",
    templateUrl: "templates/splash.html",
    controller: 'LoginCtrl',
    onEnter: function() {
      // analytics.trackView('Login');
    }
  })
  .state('forgot', {
    url: "/forgot",
    templateUrl: "templates/forgot.html",
    controller: 'ForgotCtrl',
    onEnter: function() {
      // analytics.trackView('Login');
    }
  })  

  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl'
  })

  .state('app.home', {
    url: '/home',
    views: {
      'menuContent': {
        templateUrl: 'templates/home.html',
        controller: 'HomeCtrl'
      }
    },
    onEnter: function() {
      if (typeof analytics !== 'undefined') analytics.trackView('Home');
    }
  })
  .state('app.single', {
    url: '/single/:id/:name',
    views: {
      'menuContent': {
        templateUrl: 'templates/single.html',
        controller: 'SingleCtrl'
      }
    },
    onEnter: function($stateParams) {
      if (typeof analytics !== 'undefined') analytics.trackView('Post: '+$stateParams.name);
    }
  })
  .state('app.colleagues', {
    url: '/colleagues',
    views: {
      'menuContent': {
        templateUrl: 'templates/colleagues.html',
        controller: 'ColleaguesCtrl'
      }
    },
    onEnter: function() {
      if (typeof analytics !== 'undefined') analytics.trackView('Colleagues');
    }
  })
  .state('app.advance', {
    url: '/advance',
    views: {
      'menuContent': {
        templateUrl: 'templates/advance.html',
        controller: 'AdvanceCtrl'
      }
    },
    onEnter: function() {
      if (typeof analytics !== 'undefined') analytics.trackView('Colleagues Advance Search');
    }
  })
  .state('app.results', {
    url: '/results/:country/:especialty/:query',
    views: {
      'menuContent': {
        templateUrl: 'templates/results.html',
        controller: 'ResultsCtrl'
      }
    },
    onEnter: function() {
      if (typeof analytics !== 'undefined') analytics.trackView('Colleagues Advance Results');
    }
  })  
  .state('app.events', {
    url: '/events',
    views: {
      'menuContent': {
        templateUrl: 'templates/events.html',
        controller: 'EventsCtrl'
      }
    },
    onEnter: function() {
      if (typeof analytics !== 'undefined') analytics.trackView('Events');
    }
  })
  .state('app.event', {
    url: '/event/:id',
    views: {
      'menuContent': {
        templateUrl: 'templates/event.html',
        controller: 'EventCtrl'
      }
    },
    onEnter: function($stateParams) {
      if (typeof analytics !== 'undefined') analytics.trackView('Evento: '+$stateParams.name);
    }
  })
  .state('app.eventpost', {
    url: '/eventpost/:id/:name',
    views: {
      'menuContent': {
        templateUrl: 'templates/eventpost.html',
        controller: 'EventPostCtrl'
      }
    },
    onEnter: function($stateParams) {
      if (typeof analytics !== 'undefined') analytics.trackView('Evento Post: '+$stateParams.name);
    }
  })    
  .state('app.doctor', {
    url: '/doctor/:id/:name',
    views: {
      'menuContent': {
        templateUrl: 'templates/doctor.html',
        controller: 'DoctorCtrl'
      }
    },
    onEnter: function($stateParams) {
      if (typeof analytics !== 'undefined') analytics.trackView('Doctor: '+$stateParams.name);
    }
  })
  .state('app.specialities', {
    url: '/specialities',
    views: {
      'menuContent': {
        templateUrl: 'templates/especialities.html',
        controller: 'SpecialitiesCtrl'
      }
    },
    onEnter: function() {
      if (typeof analytics !== 'undefined') analytics.trackView('Specialties');
    }
  })
  .state('app.speciality', {
    url: '/speciality/:id/:name',
    views: {
      'menuContent': {
        templateUrl: 'templates/speciality.html',
        controller: 'SpecialityCtrl'
      }
    },
    onEnter: function($stateParams) {
      if (typeof analytics !== 'undefined') analytics.trackView('Specialty: '+$stateParams.name);
    }
  })
  .state('app.notifications', {
    url: '/notifications',
    views: {
      'menuContent': {
        templateUrl: 'templates/notifications.html',
        controller: 'NotificationsCtrl'
      }
    },
    onEnter: function() {
      // if (typeof analytics !== 'undefined') analytics.trackView('Share')
    }
  })   
  .state('app.share', {
    url: '/share',
    views: {
      'menuContent': {
        templateUrl: 'templates/share.html',
        controller: 'ShareCtrl'
      }
    },
    onEnter: function() {
      if (typeof analytics !== 'undefined') analytics.trackView('Share')
    }
  }) 
  .state('app.viewpdf', {
    url: '/viewpdf/:tipo/:archivo',
    views: {
      'menuContent': {
        templateUrl: 'templates/pdfviewer.html',
        controller: 'PDFCtrl'
      }
    }
  })


  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/home');
});
