var urlBase = "http://sculapio.com/apiv2/";

angular.module('sculapio.controllers')

.factory('$localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    },
    remove: function(key) {
      return $window.localStorage.removeItem(key);
    }
  }
}])

.factory('Auth', function($localstorage, $rootScope, $http, $state, MessagesTotal){
  var service = {};

  service.setCredentials = function(todalainfo){

        Ionic.io();
        var push = new Ionic.Push({
          // "debug": true,
          onNotification: function(notification){
            if (notification._payload.state && !notification._raw.additionalData.foreground ) {
              $state.go(notification._payload.state, JSON.parse(notification._payload.stateParams));
            }
            MessagesTotal.get({
              idusuario: $rootScope.globals2.currentUser.idusuario,
              idespecialidad: $rootScope.globals2.currentUser.especialidades_usuario
            }).$promise.then(function(res){
              $rootScope.mensajes.total = res.total;
            });
          },
          "pluginConfig": {
            "ios": {
              "badge": true,
              "sound": true
            },
            "android": {
              "iconColor": "#0171bb",
              "icon": "sculapio_ic"
            }
          }
        });

        push.register(function(pushToken) {
          var user = Ionic.User.current();
          user.id = todalainfo.idusuario;
          user.set('image', 'http://sculapio.com/assets/res/users/'+(todalainfo.foto || 'no-user.png'));
          user.set('name', todalainfo.nombre);
          console.log("Device token:",pushToken.token);
          user.addPushToken(pushToken);
          user.save();
        });


      $rootScope.globals2 = {
          currentUser: todalainfo
      };
      $localstorage.setObject('globals2',{currentUser:todalainfo});
  }

  service.clearCredentials = function(){
      $rootScope.globals2 = {};
      // $http.get('');
      $localstorage.setObject('globals2',{});
      Ionic.io();
      var push = new Ionic.Push({
        // "debug": true
      });      
      var user = Ionic.User.current();
      $localstorage.remove('ionic_io_user_356d6da3')

  }

  return service;
})


.factory('Login', function($resource, $httpParamSerializer){
  // return $resource(urlBase+'login');
  	return $resource(urlBase+'login', null, {
    	'save': {
        	method:'POST',
        	headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
        	transformRequest: function(data) {
        		return $httpParamSerializer(data);
        	}
    	}
  	});
})
// .factory('Login', function($resource){
//   return $resource('http://hqhtest.herokuapp.com:80/api/Members/login');
// })
.factory('Posts', function($resource){
  return $resource(urlBase+'tomar_posts');
})
.factory('Acuerdo', function($resource, $httpParamSerializer){
  // return $resource(urlBase+'enviar_acuerdo');
  	return $resource(urlBase+'enviar_acuerdo', null, {
    	'save': {
        	method:'POST',
        	headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
        	transformRequest: function(data) {
        		return $httpParamSerializer(data);
        	}
    	}
  	});  
})
.factory('Desacuerdo', function($resource, $httpParamSerializer){
  // return $resource(urlBase+'enviar_desacuerdo');
  	return $resource(urlBase+'enviar_desacuerdo', null, {
    	'save': {
        	method:'POST',
        	headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
        	transformRequest: function(data) {
        		return $httpParamSerializer(data);
        	}
    	}
  	});  
})
.factory('Post', function($resource){
	return $resource(urlBase+'tomar_post');
})
.factory('PostMedia', function($resource){
	return $resource(urlBase+'tomar_archivos_post');
})
.factory('Comments', function($resource){
	return $resource(urlBase+'tomar_comentarios_post');
})
.factory('PostComment', function($resource, $httpParamSerializer){
	// return $resource(urlBase+'enviar_comentario');
  	return $resource(urlBase+'enviar_comentario', null, {
    	'save': {
        	method:'POST',
        	headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
        	transformRequest: function(data) {
        		return $httpParamSerializer(data);
        	}
    	}
  	});	
})
.factory('Doctor', function($resource){
	return $resource(urlBase+'tomar_datos_usuario');
})
.factory('Certify', function($resource, $httpParamSerializer){
	// return $resource(urlBase+'enviar_certificacion');
  	return $resource(urlBase+'enviar_certificacion', null, {
    	'save': {
        	method:'POST',
        	headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
        	transformRequest: function(data) {
        		return $httpParamSerializer(data);
        	}
    	}
  	});		
})
.factory('Forgot', function($resource, $httpParamSerializer){
  // return $resource(urlBase+'enviar_certificacion');
    return $resource(urlBase+'recuperar_clave', null, {
      'save': {
          method:'POST',
          headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
          transformRequest: function(data) {
            return $httpParamSerializer(data);
          }
      }
    });   
})
.factory('Countries', function($resource){
  return $resource(urlBase+'tomar_paises');
})
.factory('Messages', function($resource){
  return $resource(urlBase+'tomar_mensajes');
})
.factory('MessagesTotal', function($resource){
  return $resource(urlBase+'tomar_mensajes_total');
})
.factory('Specialities', function($resource){
	return $resource(urlBase+'tomar_especialidades');
})
.factory('Colleagues', function($resource){
	return $resource(urlBase+'tomar_colegas');
})
.factory('Events', function($resource){
	return $resource(urlBase+'tomar_eventos');
})
.factory('EventPosts', function($resource){
	return $resource(urlBase+'tomar_evento_posts');
})
.factory('Event', function($resource){
	return $resource(urlBase+'tomar_evento_post');
})
.factory('EventComments', function($resource){
	return $resource(urlBase+'tomar_comentarios_evento_post');
})
.factory('EventMedia', function($resource){
	return $resource(urlBase+'tomar_archivos_evento');
})
.factory('SubirArchivo', function($resource, $httpParamSerializer){
//	return $resource(urlBase+'enviar_archivo');
  	return $resource(urlBase+'enviar_archivo', null, {
    	'save': {
        	method:'POST',
        	headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
        	transformRequest: function(data) {
        		return $httpParamSerializer(data);
        	}
    	}
  	});
})
.factory('Marcar', function($resource){
  return $resource(urlBase+'marcar_leido');
})
.factory('EnviarPost', function($resource, $httpParamSerializer){
	// return $resource(urlBase+'');
  	return $resource(urlBase+'enviar_post', null, {
    	'save': {
        	method:'POST',
        	headers:{'Content-Type':'application/x-www-form-urlencoded; charset=UTF-8'},
        	transformRequest: function(data) {
        		return $httpParamSerializer(data);
        	}
    	}	
  	});
})